function send(address, message, port)
%SEND
%This function sends a message to a certain address through certain PC
%ports.  If no ports are specified, all existing ports are used.
%
%Usage: 
%       send(address, message, port);
%
% address: any number between 0-65535
% message: a subclass of net.tinyos.message.Message
% port: a socket, eg. 'localhost:9000' or a serial port, eg. 'COM1'

global COMM

if nargin<3
    port=COMM.sockets;
end

if iscell(port)
    for i=1:length(port)
        send(address, message, port{i});
    end
    return
end

if ~ischar(port) | ~isnumeric(address) | ~isjava(message)
    disp('usage: send(COMM.broadcastAddress, net.tinyos.oscope.OscopeMsg'')');
    disp(['       send(COMM.broadcastAddress, net.tinyos.oscope.OscopeMsg'', ''COM1'')']);
    return
end

moteIF=connect(port);
moteIF.send(address, message);
    
      